//+------------------------------------------------------------------+
//|                                           MACD_OSMA__Bar_MTF.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property  copyright "ray_donglei"
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property  indicator_buffers 2
#property  indicator_color1  Lime
#property  indicator_color2  Lime
extern int devPeriod   =20;  
double devupBuffer[];
double devdwBuffer[];
double stdBuffer[];
double maBuffer[];



//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int init()
{
 string short_name;  
   
   
   
   IndicatorBuffers(2);
   
//--- indicator lines
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, devupBuffer);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1,devdwBuffer );
   SetIndexBuffer(2,stdBuffer );
   SetIndexBuffer(3,maBuffer );
   
    
   short_name="devupdw(" + devPeriod + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);
   
   return(0);
   
  }
  
  
int start()
{  
   int i,limit,y=0,counted_bars = IndicatorCounted();
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit = Bars - counted_bars;
        
   
   
   
    for (i=limit; i>= 0; i--)
   {   stdBuffer[i]=iStdDev(NULL,0,devPeriod,0,MODE_SMA,PRICE_CLOSE, i);
       
       maBuffer[i]=iMA(NULL,0,devPeriod,0,MODE_SMA,PRICE_CLOSE,i);
     if (stdBuffer[i]==0.0) devupBuffer[i]=0;
     else devupBuffer[i]=ccistatus(i,1,NULL)/stdBuffer[i]*stdBuffer[i];
     if (stdBuffer[i]==0.0) devdwBuffer[i]=0;
       else devdwBuffer[i]=ccistatus(i,-1,NULL)/stdBuffer[i]*stdBuffer[i];
   }     
   return(0);
}
//+------------------------------------------------------------------+
int ccistatus(int pos,int dir,int TimeFrame)
{
      double ccival[];
      int count=0; 
      int ret=0;
      int y =iBarShift(NULL,TimeFrame,Time[pos]);
    
      for (int i=y;i<iBars(Symbol(),TimeFrame);i++)  
      {          
         double cci0   = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i)- maBuffer[i];
         if (cci0>=0 && dir>0)
         {
         ArrayResize(ccival,count+1);
         ccival[count]=cci0*cci0;
         count++;
         }
         if (cci0<=0 && dir<0)
         {
         ArrayResize(ccival,count+1);
         ccival[count]=cci0*cci0;   
         count++; 
         }    
         if (cci0>0 && cci0<0) 
         break;
      }
      
    
      if ( dir>0 )
      ret=1;
      if ( dir<0 )
      ret=-1;
      return(ret);

}